Bug 1470842 - Review Request: bazel - A fast, scalable, multi-language and extensible build system
Review Request: bazel - A fast, scalable, multi-language and extensible build...
Status: NEW
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2017-07-13 15:12 EDT by Seth Jennings
Modified: 2017-09-18 05:55 EDT (History)
6 users (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed:
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Seth Jennings 2017-07-13 15:12:04 EDT
Spec URL: https://www.variantweb.net/pub/bazel.spec
SRPM URL: https://www.variantweb.net/pub/bazel-0.5.2-1.fc26.src.rpm

Description:
Bazel is a build tool which coordinates builds and runs tests. The extension
language allows it to work with source files written in any language, with
native support for Java, C, C++ and Python. Bazel produces builds and runs
tests for multiple platforms.

Fedora Account System Username: sjenning

Notably, this is the build tool for Kubernetes and will soon be required for developers on that project.
Comment 1 Zamir SUN 2017-07-15 08:40:07 EDT
Hi,

I think you need major fix for this package. IMO we do not allow binary file in package but there are many JAR files in source.
Besides, if you want to use ./compile.sh to build, you need to write clear justification why in the SPEC file.
Some files is with bad permission (555 while it is not actually for execute). See rpmlint details below.



This is a review *template*. Besides handling the [ ]-marked tests you are
also supposed to fix the template before pasting into bugzilla:
- Add issues you find to the list of issues on top. If there isn't such
  a list, create one.
- Add your own remarks to the template checks.
- Add new lines marked [!] or [?] when you discover new things not
  listed by fedora-review.
- Change or remove any text in the template which is plain wrong. In this
  case you could also file a bug against fedora-review
- Remove the "[ ] Manual check required", you will not have any such lines
  in what you paste.
- Remove attachments which you deem not really useful (the rpmlint
  ones are mandatory, though)
- Remove this text



Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed


Issues:
=======
- Permissions on files are set properly.
  Note: See rpmlint output
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#FilePermissions
- All build dependencies are listed in BuildRequires, except for any that
  are listed in the exceptions section of Packaging Guidelines.
  Note: These BR are not needed: gcc unzip gcc-c++
  See: http://fedoraproject.org/wiki/Packaging/Guidelines#Exceptions_2


===== MUST items =====

C/C++:
[ ]: Provides: bundled(gnulib) in place as required.
     Note: Sources not installed
[ ]: Package does not contain kernel modules.
[ ]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.

Generic:
[ ]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[ ]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Apache (v2.0)", "Apache (v2.0) NTP", "Unknown or generated".
     364 files have unknown license.
[!]: %build honors applicable compiler flags or justifies otherwise.
[!]: Package contains no bundled libraries without FPC exception.
     Note: Especially check following dirs for bundled code: third_party
[x]: Changelog in prescribed format.
[!]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[ ]: Development files must be in a -devel package
[ ]: Package uses nothing in %doc for runtime.
[!]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[ ]: Package does not generate any conflict.
[ ]: Package obeys FHS, except libexecdir and /usr/target.
[ ]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[!]: Requires correct, justified where necessary.
[ ]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[ ]: Useful -debuginfo package or justification otherwise.
[ ]: Package is not known to require an ExcludeArch tag.
[ ]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 81920 bytes in 5 files.
[ ]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[ ]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[ ]: Final provides and requires are sane (see attachments).
[ ]: Package functions as described.
[ ]: Latest version is packaged.
[ ]: Package does not include license text files separate from upstream.
[ ]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[ ]: Package should compile and build into binary rpms on all supported
     architectures.
[ ]: %check is present and all tests pass.
[ ]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package
     is arched.
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: bazel-0.5.2-1.fc25.x86_64.rpm
          bazel-0.5.2-1.fc25.src.rpm
bazel.x86_64: W: spelling-error Summary(en_US) scalable -> salable, callable, calculable
bazel.x86_64: W: spelling-error Summary(en_US) multi -> mulch, mufti
bazel.x86_64: W: unstripped-binary-or-object /usr/bin/bazel
bazel.x86_64: E: non-standard-executable-perm /usr/share/doc/bazel/CONTRIBUTING.md 555
bazel.x86_64: W: spurious-executable-perm /usr/share/doc/bazel/CONTRIBUTING.md
bazel.x86_64: E: non-standard-executable-perm /usr/share/doc/bazel/CHANGELOG.md 555
bazel.x86_64: W: spurious-executable-perm /usr/share/doc/bazel/CHANGELOG.md
bazel.x86_64: E: non-standard-executable-perm /usr/share/doc/bazel/CONTRIBUTORS 555
bazel.x86_64: W: spurious-executable-perm /usr/share/doc/bazel/CONTRIBUTORS
bazel.x86_64: E: non-standard-executable-perm /usr/share/licenses/bazel/LICENSE 555
bazel.x86_64: E: script-without-shebang /usr/share/licenses/bazel/LICENSE
bazel.x86_64: E: non-standard-executable-perm /usr/share/doc/bazel/AUTHORS 555
bazel.x86_64: W: spurious-executable-perm /usr/share/doc/bazel/AUTHORS
bazel.x86_64: E: non-standard-executable-perm /usr/share/doc/bazel/README.md 555
bazel.x86_64: W: spurious-executable-perm /usr/share/doc/bazel/README.md
bazel.x86_64: W: no-manual-page-for-binary bazel
bazel.src: W: spelling-error Summary(en_US) scalable -> salable, callable, calculable
bazel.src: W: spelling-error Summary(en_US) multi -> mulch, mufti
2 packages and 0 specfiles checked; 7 errors, 11 warnings.




Rpmlint (installed packages)
----------------------------
bazel.x86_64: W: spelling-error Summary(en_US) scalable -> salable, callable, calculable
bazel.x86_64: W: spelling-error Summary(en_US) multi -> mulch, mufti
bazel.x86_64: W: unstripped-binary-or-object /usr/bin/bazel
bazel.x86_64: E: non-standard-executable-perm /usr/share/doc/bazel/CONTRIBUTING.md 555
bazel.x86_64: W: spurious-executable-perm /usr/share/doc/bazel/CONTRIBUTING.md
bazel.x86_64: E: non-standard-executable-perm /usr/share/licenses/bazel/LICENSE 555
bazel.x86_64: E: script-without-shebang /usr/share/licenses/bazel/LICENSE
bazel.x86_64: E: non-standard-executable-perm /usr/share/doc/bazel/CONTRIBUTORS 555
bazel.x86_64: W: spurious-executable-perm /usr/share/doc/bazel/CONTRIBUTORS
bazel.x86_64: E: non-standard-executable-perm /usr/share/doc/bazel/AUTHORS 555
bazel.x86_64: W: spurious-executable-perm /usr/share/doc/bazel/AUTHORS
bazel.x86_64: E: non-standard-executable-perm /usr/share/doc/bazel/CHANGELOG.md 555
bazel.x86_64: W: spurious-executable-perm /usr/share/doc/bazel/CHANGELOG.md
bazel.x86_64: E: non-standard-executable-perm /usr/share/doc/bazel/README.md 555
bazel.x86_64: W: spurious-executable-perm /usr/share/doc/bazel/README.md
bazel.x86_64: W: no-manual-page-for-binary bazel
1 packages and 0 specfiles checked; 7 errors, 9 warnings.



Requires
--------
bazel (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libdl.so.2()(64bit)
    libgcc_s.so.1()(64bit)
    libgcc_s.so.1(GCC_3.0)(64bit)
    libm.so.6()(64bit)
    libpthread.so.0()(64bit)
    librt.so.1()(64bit)
    libstdc++.so.6()(64bit)
    libstdc++.so.6(CXXABI_1.3)(64bit)
    libstdc++.so.6(CXXABI_1.3.8)(64bit)
    rtld(GNU_HASH)



Provides
--------
bazel:
    bazel
    bazel(x86-64)



Source checksums
----------------
https://github.com/bazelbuild/bazel/releases/download/0.5.2/bazel-0.5.2-dist.zip :
  CHECKSUM(SHA256) this package     : 2418c619bdd44257a170b85b9d2ecb75def29e751b725e27186468ada2e009ea
  CHECKSUM(SHA256) upstream package : 2418c619bdd44257a170b85b9d2ecb75def29e751b725e27186468ada2e009ea


Generated by fedora-review 0.6.1 (f03e4e7) last change: 2016-05-02
Command line :/usr/bin/fedora-review -b 1470842
Buildroot used: fedora-25-x86_64
Active plugins: Generic, Shell-api, C/C++
Disabled plugins: Java, Python, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6
Comment 2 Seth Jennings 2017-07-23 23:08:48 EDT
Thanks for the review!

The release tarballs (as opposed to the -dist.zip sources) have the correct permissions on the files and don't include the bootstrap binaries.

The two binaries needed are protoc, provided by the protobuf-compiler package, and a protoc-gen-grpc-java, which current isn't packaged.  It can be compile from https://github.com/grpc/grpc-java.  However, that repo also has a recommended "build from source" procedure that includes prebundled binaries.

Still trying to find a clean way to do this.
Comment 3 Ed Marshall 2017-08-04 20:30:08 EDT
I came over to bugzilla to see if Bazel had a review request for it yet, since I'd noticed that Vincent Batts has a COPR for Bazel (they're also packaging Envoy as a COPR). Anyway, figured I'd mention it in case you were interested in collaborating with them?

https://copr.fedorainfracloud.org/coprs/vbatts/bazel/

It looks like he did the same thing as you, though (using the -dist source with pre-built jars, rather than unrolling each dependent build tool), fwiw.

Note You need to log in before you can comment on or make changes to this bug.